
%clear
%path(path, '~/htomo/work/mbin');

Nx=1440;Nz=560;Ns=29;
%x0 = 101; xf = Nx-100;
x0 = 61+360; xf = Nx-60-360;
z0 = 110; zf = Nz-50;

xplot=linspace(-Nx/8,Nx/8,Nx);

fax=8;   %Axes and Colorbar font size
fla=10;  %Title and labels font size

pl = 1;  %Plot length multiplier (1 for 4in, 2 for 8in)



%namein = '/scratch/lustreA/s/sburdic/data/Isub_20_14';
namein = '~/rftomo/htomo_subduction/error_params/Isub_All';
 
zup   =loadbin([namein 'zup']  ,'float');
zdown =loadbin([namein 'zdown'],'float');
dz    =loadbin([namein 'dz']   ,'float');
sigma =loadbin([namein 'sigma'],'float');
s1    =loadbin([namein 's1']   ,'float');
s2    =loadbin([namein 's2']   ,'float');
xi    =loadbin([namein 'x']   ,'float');
zi    =loadbin([namein 'z']   ,'float');

mms=find(s1==15 & s2==20 & zi==421);
mms=mms(1);


if 1  
    

%figfile = 'figs/dKernel_AM_sm';
figfile = 'figs/Kernel_AM_sm_cb';

titext = 'Sensitivity kernel for iteration ';
%titext = 'Change in sensitivity kernel for iteration ';

ii2=zeros(Nz,Nx,31);

for mm=2%:5:31
    I=loadbin(['~/rftomo/kernels/data/Isub_wide5Fsens' sprintf('%2d',mm)],'float');
    %I=-loadbin(['~/rftomo/kernels/data/Isub_wide5Fkern' sprintf('%2d',mm)],'float');

    ii=reshape(I,Nz,Nx,[]); 
    ii2(:,:,mm)=ii;   break         
    clf
    H=figure(1);
    %imagesc(xplot(x0:xf),0:(zf-z0)/4,ii(z0:zf,x0:xf)-ii2(z0:zf,x0:xf,1));axis equal tight; c=0.85*max(abs(caxis));caxis([-c c]);
    imagesc(xplot(x0:xf),0:(zf-z0)/4,ii(z0:zf,x0:xf));axis equal tight; c=0.85*max(abs(caxis));caxis([-c c]);
    c=0.85*max(abs(ii(:)));caxis([-c c]);
    hold on;errorbar(xplot(xi(mms)+360),(zdown(mms)+zup(mms))/8-z0/4,(zdown(mms)-zup(mms))/8,'k','linestyle','none','linewidth',1)
    hold on;scatter(xplot(xi(mms)+360),zi(mms)/4-z0/4,'k','x','linewidth',1)
    colorbar
    %caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    title([titext  num2str(mm)],'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile num2str(mm) '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf,'Units','Inches', 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');   
  
end

end






Nx=720;Nz=560;Ns=29;
x0=60;xf=Nx-60;
z0=110;zf=Nz-50;

xplot=linspace(-Nx/8,Nx/8,Nx);

fax=8;   %Axes and Colorbar font size
fla=10;  %Title and labels font size

pl = 1;  %Plot length multiplier (1 for 4in, 2 for 8in)



if 1  %LOAD FINITE DIFFERENCE INFO
    
    
    
    
    
    
g0=loadbin('~/rftomo/htomo_subduction/IKernLSJ/Isub_KernLSJ  1','float');

 nn=length(g0); 
 
 g=zeros(nn,322);
  
for mm=2:323  
  g(:,mm-1)=loadbin(['~/rftomo/htomo_subduction/IKernLSJ/Isub_KernLSJ' sprintf('%3d',mm-1)],'float');   
end

gg0=repmat(g0,1,322);




gg=zeros(23,14,nn);gtot=zeros(23*14,1);
for mm=1:nn
  gg(:,:,mm)=reshape(g(mm,:)-gg0(mm,:),23,14);
  gtot(:)=gtot(:)+(g(mm,:)'-gg0(mm,:)');
end




ixx=0;
for iz=z0+12:24:zf-16-48
    for ix=x0+36:24:xf-36
        ixx=ixx+1;
        gx(ixx)=ix;
        gz(ixx)=iz;
        ga(ixx)=(-1)^ixx*200;
    end
end

t=linspace(0,3,72);t0=[0 1 2 3];
b1=.5*(t-t0(1)).^2;
b2=-(t-t0(2)).^2+(t-t0(2))+1/2;
b3=.5*(1-(t-t0(3))).^2;
bb=[b1(1:24) b2(25:48) b3(49:72)];

bass2=zeros(71,71);
% Create spline basis for 2D
for ix=1:71;for iz=1:71;bass2(iz,ix)=bb(iz)*bb(ix);end;end


end



if 1   %PLOT FINITE DIFFERENCE VERSION
mms=find(s1==15 & s2==20 & zi==421);
for mm=mms(1);%1:1000:length(s1)
% Project test model onto spline basis
vc2=zeros(Nz,Nx);
for ig=1:ixx
  vc2(gz(ig)-35:gz(ig)+35,gx(ig)-35:gx(ig)+35) = vc2(gz(ig)-35:gz(ig)+35,gx(ig)-35:gx(ig)+35)+ (g(mm,ig)-gg0(mm,ig))*bass2;
end

    figfile = 'figs/Kernel_FD_cb';
    titext = 'Sensitivity calculated by finite difference';
    
    clf
    H=figure(1);imagesc(xplot(x0:xf),0:(zf-z0)/4,vc2(z0:zf,x0:xf));axis equal tight;c=0.8*max(abs(caxis));caxis([-c c]);
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    hold on;errorbar(xplot(xi(mm)),(zdown(mm)+zup(mm))/8-z0/4,(zdown(mm)-zup(mm))/8,'k','linestyle','none','linewidth',1)
    hold on;scatter(xplot(xi(mm)),zi(mm)/4-z0/4,'k','x','linewidth',1)
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    title([titext ],'fontsize',fla,'fontweight','bold');
    colorbar
    %title(['Sources ', num2str(s1(mm)) ' and ' num2str(s2(mm)) ', Sigma = ', num2str(sigma(mm))  ', Depth shift = ', num2str(dz(mm))],'fontsize',fla,'fontweight','bold');
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    filename = [figfile '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf, 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');   

hold off

end


end
