Nx=1440;Nz=560;Ns=29;

%x0 = 101; xf = Nx-100;
x0 = 61+360; xf = Nx-60-360;
z0 = 110; zf = Nz-50;

pl = 1;

x=linspace(-Nx/8,Nx/8,Nx);

fax=8;   %Axes and Colorbar font size
fla=10;  %Title and labels font size


I=loadbin('~/rftomo/htomo_subduction/data/dvsub_wide','float');    dv=reshape(I,Nz,Nx);






if 0  %PRINT ALL IMAGES
    

figfile = 'figs/Isub_EF';
titext = 'Image for smooth perturbation coefficient = ';

alfa=0:.25:2;

for mm=1:9
    I=loadbin(['~/rftomo/htomo_subduction/data/Isub_wideEF ' num2str(mm)],'float');
    ii=reshape(I,Nz,Nx,[]); 
    II=200*ii(:,:,1:Ns);
       
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,sum(II(z0:zf,x0:xf,:),3));axis equal tight; 
    hold on;contour(x(x0:xf),(0:(zf-z0))/4,dv(z0:zf,x0:xf),[-110 110],'k');
    %caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    title([titext  num2str(alfa(mm))],'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile num2str(mm) '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf,'Units','Inches', 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');   
  
end

end


if 0  % STARTING IMAGE
    

%figfile = 'figs/Isub_EF_1D';
figfile = 'figs/Isub_CC_1D';

titext = 'Image for 1D background model';

    I=loadbin(['~/rftomo/htomo_subduction/data/Isub_wideEF 1'],'float');
    ii=reshape(I,Nz,Nx,[]); 
    II=200*ii(:,:,1:Ns);
       
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,sum(II(z0:zf,x0:xf,:),3));axis equal tight; 
    %hold on;contour(x(x0:xf),(0:(zf-z0))/4,dv(z0:zf,x0:xf),[-110 110],'k');
    %caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
   % title(titext,'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf,'Units','Inches', 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');   

end


if 0  % TRUE IMAGE
    
%figfile = 'figs/Isub_EF_true';
figfile = 'figs/Isub_CC_true';
titext = 'Image for true background model';

    I=loadbin(['~/rftomo/htomo_subduction/data/Isub_wideEF 5'],'float');
    ii=reshape(I,Nz,Nx,[]); 
    II=200*ii(:,:,1:Ns);
       
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,sum(II(z0:zf,x0:xf,:),3));axis equal tight; 
    %hold on;contour(x(x0:xf),(0:(zf-z0))/4,dv(z0:zf,x0:xf),[-110 110],'k');
    %caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    %title(titext,'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf,'Units','Inches', 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');   
  
end

if 1  % 2X IMAGE
    
%figfile = 'figs/Isub_EF_true';
figfile = 'figs/Isub_CC_2X';
titext = 'Image for true background model';

    I=loadbin(['~/rftomo/htomo_subduction/data/Isub_wideEF 9'],'float');
    ii=reshape(I,Nz,Nx,[]); 
    II=200*ii(:,:,1:Ns);
       
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,sum(II(z0:zf,x0:xf,:),3));axis equal tight; 
    %hold on;contour(x(x0:xf),(0:(zf-z0))/4,dv(z0:zf,x0:xf),[-110 110],'k');
    %caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    %title(titext,'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf,'Units','Inches', 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');   
  
end


if 0  % Single source images
    
%figfile = 'figs/Isub_EF_true';
figfile = 'figs/Isub_CC_true';
titext = 'Image for true background model';

    I=loadbin(['~/rftomo/htomo_subduction/data/Isub_wideEF 5'],'float');
    ii=reshape(I,Nz,Nx,[]); 
    II=200*ii(:,:,1:Ns);
for mm=[7 25]

       
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,II(z0:zf,x0:xf,mm));axis equal tight; 
    %hold on;contour(x(x0:xf),(0:(zf-z0))/4,dv(z0:zf,x0:xf),[-110 110],'k');
    %caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    %title(titext,'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile num2str(mm) '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf,'Units','Inches', 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');   
  
end
end







