
Nx=1440;Nz=560;Ns=29;

%x0 = 61; xf = Nx-60;
x0 = 61+360; xf = Nx-60-360;
z0 = 110; zf = Nz-50;

x=linspace(-Nx/8,Nx/8,Nx);

fax=8;   %Axes and Colorbar font size
fla=10;  %Title and labels font size

pl = 1;  %Plot length multiplier (1 for 4in, 2 for 8in)


if 0
Nv=[5 16 23 30];

datfile = '~/rftomo/kernels/data/Isub_wide5Fvuptot';
figfile = 'figs/CG_BestParam';
titext = 'All events, 2Hz, Iteration ';
    
  for mm=Nv

    I=loadbin([datfile sprintf('%2d',mm)]);
    vuptot(:,:,mm) = reshape(I,Nz,Nx);  


    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,vuptot(z0:zf,x0:xf,mm));axis equal tight; 
    caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    title([titext  num2str(mm) '  (m/s)'],'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile num2str(mm) '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf, 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');    
    
  end
end


if 0
Nv=[36];

datfile = '~/rftomo/kernels/data/Isub_wide5FLvuptot';
figfile = 'figs/CG_LowFreq';
titext = 'All events, 1Hz, Iteration ';

  for mm=Nv

    I=loadbin([datfile sprintf('%2d',mm)]);
    vuptot(:,:,mm) = reshape(I,Nz,Nx);  
    
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,vuptot(z0:zf,x0:xf,mm));axis equal tight; 
    caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    title([titext  num2str(mm) '  (m/s)'],'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile num2str(mm) '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf, 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');    
    
  end
end



if 0
Nv=[25];

datfile = '~/rftomo/kernels/data/Isub_wide5FTvuptot';
figfile = 'figs/CG_TeleDist';
titext = 'Teleseismic distribution ';

  for mm=Nv

    I=loadbin([datfile sprintf('%2d',mm)]);
    vuptot(:,:,mm) = reshape(I,Nz,Nx);  
    
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,vuptot(z0:zf,x0:xf,mm));axis equal tight; 
    caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    %title([titext  num2str(mm) '  (m/s)'],'fontsize',12,'fontweight','bold');
    title([titext ' (m/s)'],'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile num2str(mm) '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf, 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');    
    
  end
end



if 0
Nv=[27];

datfile = '~/rftomo/kernels/data/Isub_wide5VL2vuptot';
figfile = 'figs/CG_VariableLow';
titext = 'Variable \omega, low \omega parameters ';

  for mm=Nv

    I=loadbin([datfile sprintf('%2d',mm)]);
    vuptot(:,:,mm) = reshape(I,Nz,Nx);  
    
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,vuptot(z0:zf,x0:xf,mm));axis equal tight; 
    caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    %title([titext  num2str(mm) '  (m/s)'],'fontsize',fla,'fontweight','bold');
    title([titext ' (m/s)'],'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile num2str(mm) '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf, 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');    
    
  end
end



if 0
Nv=[35];

datfile = '~/rftomo/kernels/data/Isub_wide5VHvuptot';
figfile = 'figs/CG_VariableHigh';
titext = 'Variable \omega, high \omega parameters';

  for mm=Nv

    I=loadbin([datfile sprintf('%2d',mm)]);
    vuptot(:,:,mm) = reshape(I,Nz,Nx);  
    
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,vuptot(z0:zf,x0:xf,mm));axis equal tight; 
    caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    %title([titext num2str(mm) '  (m/s)'],'fontsize',fla,'fontweight','bold');    
    title([titext ' (m/s)'],'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile num2str(mm) '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf, 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');    
    
  end
end



if 0
Nv=[28];

datfile = '~/rftomo/kernels/data/Isub_wide5Avuptot';
figfile = 'figs/CG_LimAperture';
titext = 'Limited array aperture ';

  for mm=Nv

    I=loadbin([datfile sprintf('%2d',mm)]);
    vuptot(:,:,mm) = reshape(I,Nz,Nx);  
    
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,vuptot(z0:zf,x0:xf,mm));axis equal tight; 
    caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    %title([titext  num2str(mm) '  (m/s)'],'fontsize',fla,'fontweight','bold');
    title([titext ' (m/s)'],'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile num2str(mm) '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf, 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');    
    
  end
end


if 0
Nv=[28:52];

datfile = '~/rftomo/kernels/data/Isub_wide5VLH2vuptot';
figfile = 'figs/CG_VarLowHigh2';
titext = 'Variable low to high params ';

  for mm=Nv

    I=loadbin([datfile sprintf('%2d',mm)]);
    vuptot(:,:,mm) = reshape(I,Nz,Nx);  
    
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,vuptot(z0:zf,x0:xf,mm));axis equal tight; 
    caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    %title([titext  num2str(mm) '  (m/s)'],'fontsize',fla,'fontweight','bold');
    title([titext ' (m/s)'],'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile num2str(mm) '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf, 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');    
    
  end
end


if 1
Nv=[10:10:50];

datfile = '~/rftomo/kernels/data/ItestBvuptot';
figfile = 'figs/CG_OneZtest';
titext = 'One correlation window per offset ';

  for mm=Nv

    I=loadbin([datfile sprintf('%2d',mm)]);
    vuptot(:,:,mm) = reshape(I,Nz,Nx);  
    
    clf
    H=figure(1);
    imagesc(x(x0:xf),0:(zf-z0)/4,vuptot(z0:zf,x0:xf,mm));axis equal tight; 
    caxis([-500 500]);    colorbar('YTick',[-500 -250 0 250 500],'fontsize',fax)
    set(H,'Color','w');set(H,'Units','Inches','Position',[1*pl 1 4*pl 3])
    set(gca,'YTickMode','manual','YTick',[0 20 40 60 80 100],'fontsize',fax);
    %title([titext  num2str(mm) '  (m/s)'],'fontsize',fla,'fontweight','bold');
    title([titext ' (m/s)'],'fontsize',fla,'fontweight','bold');
    xlabel('Offset (km)','fontsize',fla);ylabel('Depth (km)','fontsize',fla)
    filename = [figfile num2str(mm) '.pdf'];colormap(flipud(jet));drawnow
    set(gcf,'PaperPositionMode','auto')
    set(gcf, 'PaperSize', [4*pl 2.7]);
    print(H,filename,'-dpdf','-r200');    
    
  end
end








