module fileio
contains

!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
subroutine realin(values,filesize,filename)
  
  implicit none
  character(256)  :: filename
  integer         :: fp, filesize
  real            :: values(filesize)

  open(unit=fp,file=TRIM(filename), &
    access='sequential',recl=1*filesize,form='formatted')
  read(unit=fp,fmt='(ES15.7E2)')values
  close(fp)

end subroutine realin


!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
subroutine integerin(values,filesize,filename)
  
  implicit none
  character(256)  :: filename
  integer         :: fp, filesize,  values(filesize)

  open(unit=fp,file=TRIM(filename), &
    access='sequential',recl=1*filesize,form='formatted')
  read(unit=fp,fmt='(I2)')values
  close(fp)

end subroutine integerin


!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
subroutine realout(values,filesize,filename)
  
  implicit none
  character(256)  :: filename
  integer         :: fp, filesize
  real            :: values(filesize)

  open(unit=fp,file=TRIM(filename), &
    access='sequential',recl=1*filesize,form='formatted')
  write(unit=fp,fmt='(ES15.7E2)')values
  close(fp)

end subroutine realout



!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
subroutine complexin(values,filesize,filename)
  
  implicit none
  character(256)  :: filename
  integer         :: fp, filesize
  complex         :: values(filesize)

  open(unit=fp,file=TRIM(filename), &
    access='sequential',recl=2*filesize,form='formatted')
  read(unit=fp,fmt='(ES15.7E2)')values
  close(fp)

end subroutine complexin



!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
subroutine complexout(values,filesize,filename)
  
  implicit none
  character(256)  :: filename
  integer         :: fp, filesize
  complex         :: values(filesize)

  open(unit=fp,file=TRIM(filename), &
    access='sequential',recl=2*filesize,form='formatted')
  write(unit=fp,fmt='(ES15.7E2)')values
  close(fp)

end subroutine complexout

!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
subroutine realinb(values,filesize,filename)
  
  implicit none
  character(256)  :: filename
  integer         :: fp, filesize
  real            :: values(filesize)

  open(unit=fp,file=TRIM(filename), &
    access='direct',recl=41*filesize,form='unformatted')
  read(unit=fp,rec=1)values
  close(fp)

end subroutine realinb



!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
subroutine realoutb(values,filesize,filename)
  
  implicit none
  character(256)  :: filename
  integer         :: fp, filesize
  real            :: values(filesize)

  open(unit=fp,file=TRIM(filename), &
    access='direct',recl=1*filesize,form='unformatted')
  write(unit=fp,rec=1)values
  close(fp)

end subroutine realoutb



!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
subroutine complexinb(values,filesize,filename)
  
  implicit none
  character(256)  :: filename
  integer         :: fp, filesize
  complex         :: values(filesize)
 
  open(unit=fp,file=TRIM(filename), &
    access='direct',recl=2*filesize,form='unformatted')
  read(unit=fp,rec=1)values
  close(fp)

end subroutine complexinb



!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
subroutine complexoutb(values,filesize,filename)
  
  implicit none
  character(256)  :: filename
  integer         :: fp, filesize
  complex         :: values(filesize)

  open(unit=fp,file=TRIM(filename), &
    access='direct',recl=2*filesize,form='unformatted')
  write(unit=fp,rec=1)values
  close(fp)

end subroutine complexoutb

!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!
subroutine doubleoutb(values,filesize,filename)
  
  implicit none
  character(256)  :: filename
  integer         :: fp, filesize
  double precision         :: values(filesize)

  open(unit=fp,file=TRIM(filename), &
    access='direct',recl=2*filesize,form='unformatted')
  write(unit=fp,rec=1)values
  close(fp)

end subroutine doubleoutb

!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!

 subroutine arrayoutb(myrank, ROI, filename, X, Nz, Nx, NRHS)
  implicit none
  include 'mpif.h'

        integer                     :: NRHS, ROI,myrank    ! Real Or Imag ?
        character(len=256)          :: filename
        complex(kind=4)             :: X(Nz,Nx,NRHS)
        complex(kind=4),allocatable :: Z(:)
        integer                     :: Nz, Nx
        integer                     :: counter, rhs, zz, xx

  allocate(Z(Nz*Nx*NRHS))

if (myrank==0) print*, 'Nz',Nz,'Nx',Nx,'NRHS',NRHS

        do rhs = 1,NRHS
             do xx = 1,Nx
                 do zz = 1,Nz
		    Z(zz+Nz*(xx-1)+Nx*Nz*(rhs-1)) = X(zz,xx,rhs)

		 enddo
	     enddo
	enddo
	if (myrank==20) write(*,*) Z(100+Nz*99+Nz*Nx*(NRHS-1)),maxval(real(Z),Nz*Nx*NRHS),maxval(aimag(Z),Nz*Nx*NRHS)
	call complexoutb(Z,Nx*Nz*NRHS,filename) 

      
      deallocate(Z)
        return
    end subroutine arrayoutb
    
!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%!!

 subroutine arrayinb(myrank, ROI, filename, X, Nz, Nx,NRHS)
  implicit none
  
        integer                     :: NRHS, ROI,myrank    ! Real Or Imag ?
        character(len=256)          :: filename
        complex(kind=4)             :: X(Nz,Nx,NRHS),j
        complex(kind=4),allocatable :: Z(:)
        integer                     :: Nz, Nx
        integer                     :: counter, rhs, zz, xx
	real 			    :: tmpr, tmpi
	
	  allocate(Z(Nz*Nx*NRHS))
	  if (myrank==0) print*, 'Nz',Nz,'Nx',Nx,'NRHS',NRHS
	  
	call complexinb(Z,Nx*Nz*NRHS,filename)
	 if (myrank==20) write(*,*) Z(100+Nz*99+Nz*Nx*(NRHS-1)),maxval(real(Z),Nz*Nx*NRHS),maxval(aimag(Z),Nz*Nx*NRHS)
        do rhs = 1,NRHS
             do xx = 1,Nx
                 do zz = 1,Nz
		    X(zz,xx,rhs) = Z(zz+Nz*(xx-1)+Nx*Nz*(rhs-1)) 
		 enddo
	     enddo
	enddo
	
      deallocate(Z)
      
      
        return
    end subroutine arrayinb
end module fileio

